// --------------------------------------------
// Unit d'interface avec la dll m3d
// par Sad Koudache, 1996-2007
// --------------------------------------------

unit M3d_;

interface

function charge_dll_m3d : boolean;
procedure decharge_dll_m3d;

function fin_partie : integer;
function machine_joue : integer;
procedure joueur_joue (coup : integer);
procedure nouvelle_partie;
function que_contient_la_case (c : integer) : byte;
procedure donner_cases_de_gain (var cd, ca : integer);

implementation
uses {Forms,} windows, dialogs, Sysutils;

type
     PInt = ^integer;
     T_MACHINE_JOUE = function (coup : PInt) : integer;  stdcall ;
     T_JOUEUR_JOUE  = function (coup : integer; quoi : integer) : integer;  stdcall ;
     T_NOUVELLE_PARTIE = procedure stdcall ;
     T_QUE_CONTIENT_LA_CASE = function (c : integer) : integer; stdcall;
     T_DONNER_CASES_DE_GAIN = procedure (cd, ca : PInt); stdcall;

var code_fin_partie  : integer;
    DLL_MACHINE_JOUE : T_MACHINE_JOUE;
    DLL_JOUEUR_JOUE  : T_JOUEUR_JOUE;
    DLL_NOUVELLE_PARTIE : T_NOUVELLE_PARTIE;
    DLL_QUE_CONTIENT_LA_CASE : T_QUE_CONTIENT_LA_CASE;
    DLL_DONNER_CASES_DE_GAIN : T_DONNER_CASES_DE_GAIN;

    m3d_dll : longint;



function charge_dll_m3d : boolean;
var ok : boolean;
begin
  m3d_dll := LoadLibrary ('m3d.dll');
  OK := (m3d_dll > 32);

  if (OK) then
  begin
    DLL_NOUVELLE_PARTIE      := GetProcAddress (m3d_dll, 'nouvelle_partie');
    DLL_MACHINE_JOUE         := GetProcAddress (m3d_dll, 'machine_joue');
    DLL_JOUEUR_JOUE          := GetProcAddress (m3d_dll, 'joueur_joue');
    DLL_QUE_CONTIENT_LA_CASE := GetProcAddress (m3d_dll, 'que_contient_la_case');
    DLL_DONNER_CASES_DE_GAIN := GetProcAddress (m3d_dll, 'donner_cases_de_gain');
  end
  else
    ShowMessage ('pb chgt m3d.dll');

  Result := OK;
end;


procedure decharge_dll_m3d;
begin
  if (m3d_dll <> 0) then
  begin
    FreeLibrary (m3d_dll);
    m3d_dll := 0;
  end;
end;

function fin_partie : integer;
begin
  Result := code_fin_partie;
end;

function machine_joue : integer;
var coup : integer;
begin
  code_fin_partie := DLL_MACHINE_JOUE (@coup);
  Result := coup;
end;

procedure joueur_joue (coup : integer);
begin
  code_fin_partie := DLL_JOUEUR_JOUE (coup, 1);
end;

procedure nouvelle_partie;
begin
  code_fin_partie := 0;
  DLL_NOUVELLE_PARTIE;
end;


function que_contient_la_case (c : integer) : byte;
begin
  Result := DLL_QUE_CONTIENT_LA_CASE (c);
end;


procedure donner_cases_de_gain (var cd, ca : integer);
begin
  DLL_DONNER_CASES_DE_GAIN (@cd, @ca);
end;


end.
