// --------------------------------------------
// Jeu de morpion 3D 4x4x4x4
// en Delphi et Assembleur
//
// par Sad Koudache, 1996-2007
// --------------------------------------------

unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls, ExtCtrls, m3d_;

type
  TForm1 = class(TForm)
    Bt_Machine_commence: TButton;
    Bt_Joueur_commence: TButton;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Button1: TButton;
    procedure Quitter1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Bt_Joueur_commenceClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Bt_Machine_commenceClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-dclarations }
  public
    joueur_doit_jouer : boolean;
    mon_message : word;
//    TS : TStringList;  // debug
  public
    procedure Afficher_pion (n : integer; col : TColor);
    procedure Machine_doit_jouer;
    procedure calculer_zones;
    function POINT (x, y : integer) : TPOINT;
    procedure Tracer_Ligne_de_gain;

    procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
end;

const EV_JOUEUR_DOIT_JOUER  = 1;
const EV_MACHINE_DOIT_JOUER = 2;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Quitter1Click(Sender: TObject);
begin
  close;
end;

const
XD = 100;
YD = 30;
PY = 60;

type
  T_ZONE = record
    r : TRECT;
    n : Byte;
    coords : string [3];
  end;

var zones : array [1..64] of T_ZONE;

const JOUEUR  = 1;
const MACHINE = 4;


procedure TForm1.FormPaint(Sender: TObject);
var i : integer;
    b : byte;
begin
  Canvas.Pen.Color := clYellow;
  Canvas.Pen.Width := 2;

  for i := 0 to 3 do
  begin
    Canvas.MoveTo (XD + 45, YD + i * PY);
    Canvas.LineTo (XD + 45 + 135, YD + i * PY);

    Canvas.MoveTo (XD, YD + 45 + i * PY);
    Canvas.LineTo (XD + 225, YD + 45 + i * PY);

    Canvas.MoveTo (XD + 45, YD + i * PY);
    Canvas.LineTo (XD, YD + 45 + i * PY);

    Canvas.MoveTo (XD + 45 + 135, YD + i * PY);
    Canvas.LineTo (XD + 225, YD + 45 + i * PY);

    Canvas.MoveTo (XD + 90, YD + i * PY);
    Canvas.LineTo (XD + 75, YD + 45 + i * PY);

    Canvas.MoveTo (XD + 135, YD + i * PY);
    Canvas.LineTo (XD + 150, YD + 45 + i * PY);

    Canvas.MoveTo (XD + 30, YD + 15 + i * PY);
    Canvas.LineTo (XD + 150 + 45, YD + 15 + i * PY);

    Canvas.MoveTo (XD + 15, YD + 30 + i * PY);
    Canvas.LineTo (XD + 150 + 60, YD + 30 + i * PY);
  end;

  for i := 1 to 64 do
  begin
    b := que_contient_la_case (zones [i].n);

    if (b = JOUEUR) then Afficher_pion (i, clRed);
    if (b = MACHINE) then Afficher_pion (i, clBlue);
  end;

  Tracer_Ligne_de_gain;
end;

procedure TForm1.Button3Click(Sender: TObject);
var i, x, y : integer;
begin
  for i := 0 to 3 do
  begin
    x := 45;
    y := 0;
    inc (x, XD);
    inc (y, i * PY + YD);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);

    x := 90;
    y := 0;
    inc (x, XD);
    inc (y, i * PY + YD);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);

    x := 135;
    y := 0;
    inc (x, XD);
    inc (y, i * PY + YD);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);

    x := 180;
    y := 0;
    inc (x, XD);
    inc (y, i * PY + YD);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);


    y := 15;
    x := 45 - y;
    inc (x, XD);
    inc (y, YD + i * PY);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);

    y := 30;
    x := 45 - y;
    inc (x, XD);
    inc (y, YD + i * PY);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);

    y := 45;
    x := 45 - y;
    inc (x, XD);
    inc (y, YD + i * PY);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);


    { 2me ligne verticale }
    y := 15;
    x := (y - 270) div -3;
    inc (x, XD);
    inc (y, YD + i * PY);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);

    y := 30;
    x := (y - 270) div -3;
    inc (x, XD);
    inc (y, YD + i * PY);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);

    y := 45;
    x := (y - 270) div -3;
    inc (x, XD);
    inc (y, YD + i * PY);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);


    { 3 me ligne verticale }
    y := 15;
    x := (y + 405) div 3;
    inc (x, XD);
    inc (y, YD + i * PY);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);

    y := 30;
    x := (y + 405) div 3;
    inc (x, XD);
    inc (y, YD + i * PY);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);

    y := 45;
    x := (y + 405) div 3;
    inc (x, XD);
    inc (y, YD + i * PY);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);

    { 4 me ligne verticale }
    y := 15;
    x := y + 180;
    inc (x, XD);
    inc (y, YD + i * PY);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);

    y := 30;
    x := y + 180;
    inc (x, XD);
    inc (y, YD + i * PY);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);

    y := 45;
    x := y + 180;
    inc (x, XD);
    inc (y, YD + i * PY);

    Canvas.Pen.Color := clRed;
    Canvas.Rectangle (x - 1, y - 1, x + 2, y + 2);
  end;
end;

procedure dans_zone (ind : integer; n : byte; x, y : integer; L, C : char);
begin
  zones [ind].r.left := x - 4;
  zones [ind].r.top := y - 4;
  zones [ind].r.right := x + 5;
  zones [ind].r.bottom := y + 5;
  zones [ind].n := n;

  zones [ind].coords := CHAR(BYTE('A') + (ind - 1) div 16) + L + C;
end;

procedure TForm1.calculer_zones;
var i, x, y : integer;
begin
  for i := 0 to 3 do
  begin
    x := 45;
    y := 0;
    inc (x, XD);
    inc (y, i * PY + YD);
    dans_zone (1 + i * 16, 61 + i * 40, x, y, 'a', '1');

    x := 90;
    y := 0;
    inc (x, XD);
    inc (y, i * PY + YD);
    dans_zone (2 + i * 16, 62 + i * 40, x, y, 'a', '2');

    x := 135;
    y := 0;
    inc (x, XD);
    inc (y, i * PY + YD);
    dans_zone (3 + i * 16, 63 + i * 40, x, y, 'a', '3');

    x := 180;
    y := 0;
    inc (x, XD);
    inc (y, i * PY + YD);
    dans_zone (4 + i * 16, 64 + i * 40, x, y, 'a', '4');

    { 2me ligne verticale }
    y := 15;
    x := 45 - y;
    inc (x, XD);
    inc (y, YD + i * PY);
    dans_zone (5 + i * 16, 66 + i * 40, x, y, 'b', '1');

    y := 30;
    x := 45 - y;
    inc (x, XD);
    inc (y, YD + i * PY);
    dans_zone (6 + i * 16, 71 + i * 40, x, y, 'c', '1');

    y := 45;
    x := 45 - y;
    inc (x, XD);
    inc (y, YD + i * PY);
    dans_zone (7 + i * 16, 76 + i * 40, x, y, 'd', '1');

    { 2me ligne verticale }
    y := 15;
    x := (y - 270) div -3;
    inc (x, XD);
    inc (y, YD + i * PY);
    dans_zone (8 + i * 16, 67 + i * 40, x, y, 'b', '2');

    y := 30;
    x := (y - 270) div -3;
    inc (x, XD);
    inc (y, YD + i * PY);
    dans_zone (9 + i * 16, 72 + i * 40, x, y, 'c', '2');

    y := 45;
    x := (y - 270) div -3;
    inc (x, XD);
    inc (y, YD + i * PY);
    dans_zone (10 + i * 16, 77 + i * 40, x, y, 'd', '2');

    { 3 me ligne verticale }
    y := 15;
    x := (y + 405) div 3;
    inc (x, XD);
    inc (y, YD + i * PY);
    dans_zone (11 + i * 16, 68 + i * 40, x, y, 'b', '3');

    y := 30;
    x := (y + 405) div 3;
    inc (x, XD);
    inc (y, YD + i * PY);
    dans_zone (12 + i * 16, 73 + i * 40, x, y, 'c', '3');

    y := 45;
    x := (y + 405) div 3;
    inc (x, XD);
    inc (y, YD + i * PY);
    dans_zone (13 + i * 16, 78 + i * 40, x, y, 'd', '3');

    { 4 me ligne verticale }
    y := 15;
    x := y + 180;
    inc (x, XD);
    inc (y, YD + i * PY);
    dans_zone (14 + i * 16, 69 + i * 40, x, y, 'b', '4');

    y := 30;
    x := y + 180;
    inc (x, XD);
    inc (y, YD + i * PY);
    dans_zone (15 + i * 16, 74 + i * 40, x, y, 'c', '4');

    y := 45;
    x := y + 180;
    inc (x, XD);
    inc (y, YD + i * PY);
    dans_zone (16 + i * 16, 79 + i * 40, x, y, 'd', '4');
  end;
end;


procedure TForm1.Bt_Joueur_commenceClick(Sender: TObject);
begin
//  TS.Clear;
  nouvelle_partie;
  refresh;
  PostMessage (Form1.Handle, mon_message, EV_JOUEUR_DOIT_JOUER, 0);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
 // TS := TStringList.Create;
  mon_message := RegisterWindowMessage ('3D morpion SK');
  Application.OnMessage := AppMessage;

  calculer_zones;
  joueur_doit_jouer := FALSE;
  Label1.Caption := 'Viens me dfier, je t''attends !';

  charge_dll_m3d;
end;


procedure TForm1.AppMessage(var Msg : TMsg; var Handled : Boolean);
begin
  if (Msg.Message = mon_message) then
  begin
    case Msg.WParam of
      EV_JOUEUR_DOIT_JOUER  :
        begin
          joueur_doit_jouer := TRUE;
          Label1.Caption := 'A vous de jouer !';
        end;
      EV_MACHINE_DOIT_JOUER : machine_doit_jouer;
    end;

    Handled := TRUE;
  end;
end;


function TForm1.POINT (x, y : integer) : TPOINT;
var tp : TPOINT;
begin
  tp.x := x;
  tp.y := y;
  Result := tp;
end;


procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var i : integer;
    ok : integer;
begin
  if (not joueur_doit_jouer) then Exit;

  ok := 0;

  for i := 1 to 64 do
  begin
    if (ptInRect (zones [i].r, POINT(x, y)) ) then
    begin
      ok := i;
      break;
    end;
  end;

  if (ok <> 0) then
  begin
    if (que_contient_la_case (zones [ok].n) = 0) then Screen.Cursor := crCross;
  end
  else
     Screen.Cursor := crDefault;
end;


procedure TForm1.Afficher_pion (n : integer; col : TColor);
begin
  Canvas.Brush.Style := bsSolid;
  Canvas.Brush.Color := col;
  Canvas.Pen.Color := col;

  Canvas.Rectangle (zones [n].r.left, zones [n].r.top, zones [n].r.right, zones [n].r.bottom);
end;


procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i : integer;
    ok : integer;
begin
  if (not joueur_doit_jouer) then Exit;

  ok := 0;

  for i := 1 to 64 do
  begin
    if (ptInRect (zones [i].r, POINT(x, y)) ) then
    begin
      ok := i;
      break;
    end;
  end;

  if (ok <> 0) then
  begin
    //TS.Add ('J ' + inttostr(zones [ok].n));
    //TS.SaveToFile ('partie.txt');

    JOUEUR_JOUE (zones [ok].n);
    i := fin_partie;

    if (i < 0) then
    begin
      { MessageBeep (0); }
      Label1.Caption := 'Erreur, vous ne pouvez pas !';
    end
    else
    begin
      Afficher_pion (ok, clRed);

      if (i = 1) then
      begin
        Label1.Caption := 'Vous gagnez';
        Tracer_Ligne_de_gain;
        Screen.Cursor := crDefault;
        joueur_doit_jouer := FALSE;
      end
      else
        if (i = 2) then
        begin
          Label1.Caption := 'Match nul';
          Screen.Cursor := crDefault;
          joueur_doit_jouer := FALSE;
        end
        else
          PostMessage (Form1.Handle, mon_message, EV_MACHINE_DOIT_JOUER, 0);
    end
  end;
end;


procedure TForm1.Bt_Machine_commenceClick(Sender: TObject);
begin
//  TS.Clear;
  nouvelle_partie;
  refresh;
  PostMessage (Form1.Handle, mon_message, EV_MACHINE_DOIT_JOUER, 0);
end;


procedure TForm1.Machine_doit_jouer;
var i : integer;
    ok : integer;
begin
  joueur_doit_jouer := FALSE;

  ok := machine_joue;
  if (ok > 0) then
  begin
    for i := 1 to 64 do
    begin
      if (zones [i].n = ok) then
      begin
        ok := i;
        break;
      end;
    end;
  end;

  if (ok > 0) then
  begin
    //TS.Add ('M ' + inttostr(zones [ok].n));
    //TS.SaveToFile ('partie.txt');

    Afficher_pion (ok, clBlue);
    Label26.Caption := 'J''ai jou en ' + zones [ok].coords;

    i := fin_partie;
    if (i = 1) then
    begin
      Label1.Caption := 'J''ai gagn';
      Tracer_Ligne_de_gain;
      Screen.Cursor := crDefault;
    end;

    if (i = 2) then
    begin
      Label1.Caption := 'Match nul';
      Screen.Cursor := crDefault;
    end;

    if (i = 0) then
       PostMessage (Form1.Handle, mon_message, EV_JOUEUR_DOIT_JOUER, 0);
  end;
end;

procedure TForm1.Tracer_Ligne_de_gain;
var x1, x2, y1, y2, i, cd, ca, s, d : integer;
begin
  donner_cases_de_gain (cd, ca);
  if (cd = 0) and (ca = 0) then Exit;

  d := (ca - cd) div 3;

  for s := 1 to 3 do
  begin
    ca := cd + d;

    for i := 1 to 64 do
    begin
      if (zones [i].n = cd) then
      begin
        x1 := zones [i].r.left + 4;
        y1 := zones [i].r.top + 4;
      end;

      if (zones [i].n = ca) then
      begin
        x2 := zones [i].r.left + 4;
        y2 := zones [i].r.top + 4;
      end;
    end;

    Canvas.Pen.Width := 2;
    Canvas.Pen.Color := clPurple;
    Canvas.MoveTo (x1, y1);
    Canvas.LineTo (x2, y2);

    cd := ca;
  end;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  //TS.free;
  decharge_dll_m3d;
end;

end.
